/* UrlMappings - http://gate.ac.uk/ - (c) Univ Shef - AGPL licenced */

class UrlMappings {
  static excludes = [
    '/WEB-INF/*', '/css/*', '/js/*', '/gwt/*', '/images/*', '/plugins/*',
    '//plugins/*', '/admin/dbconsole',
  ]

  static mappings = {

    // most controllers go under admin
    "/admin/$controller/$action?/$id?"{
      constraints {
        controller(validator: { ! it.equals("browse") })
      }
    }

    // browsing
    "/$path**?" {
      constraints { 
        path( validator: { 
            // strip off any leading slashes, and extract everything following
            // up to the first slash (if any)
            def firstPart = (it =~ /^\/*([^\/]*)/)[0][1] // fix vim highlighting: */
            
            // refuse to match if the first path segment is a known reserved
            // top-level name.
            firstPart != "browse" && firstPart != "admin" && firstPart != "dbconsole"
        } )
      }
      controller = "browse"
      action = "index"
    }

    // top level stuff
    "/admin" {
      controller = "admin"
      action = "index"
    }
    "500"(view:'/error')

  } // mappings
} // UrlMappings

/* the defaults:
static mappings = {
  "/$controller/$action?/$id?"{
    constraints { }
  }
  "/"(view:"/index")
  "500"(view:'/error')
}
*/
